package com.ftdi;

import java.nio.CharBuffer;
import java.util.Properties;
import java.util.concurrent.TimeoutException;

import com.ftdi.io.SerialPort;
import com.ftdi.io.JSSCSerialPort;
import com.ftdi.io.SerialPortListener;
import com.ftdi.util.AppProperties;

public class FT90x {

	public enum DIRECTION
	{
		INPUT,
		OUTPUT
	};
	
	public static final int GPIO_0 = 0;
	public static final int GPIO_1 = 1;
	public static final int GPIO_2 = 2;
	public static final int GPIO_3 = 3;
	public static final int GPIO_4 = 4;
	public static final int GPIO_5 = 5;
	public static final int GPIO_6 = 6;
	public static final int GPIO_7 = 7;
	public static final int GPIO_8 = 8;
	public static final int GPIO_9 = 9;
	public static final int GPIO_10 = 10;
	public static final int GPIO_11 = 11;
	public static final int GPIO_12 = 12;
	public static final int GPIO_13 = 13;
	public static final int GPIO_14 = 14;
	public static final int GPIO_15 = 15;
	public static final int GPIO_16 = 16;
	public static final int GPIO_17 = 17;
	public static final int GPIO_18 = 18;
	public static final int GPIO_19 = 19;
	public static final int GPIO_20 = 20;
	public static final int GPIO_21 = 21;
	public static final int GPIO_22 = 22;
	public static final int GPIO_23 = 23;
	public static final int GPIO_24 = 24;
	public static final int GPIO_25 = 25;
	public static final int GPIO_26 = 26;
	public static final int GPIO_27 = 27;
	public static final int GPIO_28 = 28;
	public static final int GPIO_29 = 29;
	public static final int GPIO_30 = 30;
	public static final int GPIO_31 = 31;
	public static final int GPIO_32 = 32;
	public static final int GPIO_33 = 33;
	public static final int GPIO_34 = 34;
	public static final int GPIO_35 = 35;
	public static final int GPIO_36 = 36;
	public static final int GPIO_37 = 37;
	public static final int GPIO_38 = 38;
	public static final int GPIO_39 = 39;
	public static final int GPIO_40 = 40;
	public static final int GPIO_41 = 41;
	public static final int GPIO_42 = 42;
	public static final int GPIO_43 = 43;
	public static final int GPIO_44 = 44;
	public static final int GPIO_45 = 45;
	public static final int GPIO_46 = 46;
	public static final int GPIO_47 = 47;
	public static final int GPIO_48 = 48;
	public static final int GPIO_49 = 49;
	public static final int GPIO_50 = 50;
	public static final int GPIO_51 = 51;
	public static final int GPIO_52 = 52;
	public static final int GPIO_53 = 53;
	public static final int GPIO_54 = 54;
	public static final int GPIO_55 = 55;
	public static final int GPIO_56 = 56;
	public static final int GPIO_57 = 57;
	public static final int GPIO_58 = 58;
	public static final int GPIO_59 = 59;
	public static final int GPIO_60 = 60;
	public static final int GPIO_61 = 61;
	public static final int GPIO_62 = 62;
	public static final int GPIO_63 = 63;
	public static final int GPIO_64 = 64;
	public static final int GPIO_65 = 65;
	public static final int GPIO_66 = 66;
	public static final int GPIO_VBUS_DISCHG = GPIO_0;
	public static final int GPIO_OC_N = GPIO_1;
	public static final int GPIO_PSW_N = GPIO_2;
	public static final int GPIO_VBUS_DTC = GPIO_3;
	public static final int GPIO_ENET_LED_2 = GPIO_4;
	public static final int GPIO_ENET_LED_1 = GPIO_5;
	public static final int GPIO_ADC1 = GPIO_6;
	public static final int GPIO_CAM_XCLK = GPIO_6;
	public static final int GPIO_ADC2 = GPIO_7;
	public static final int GPIO_CAM_PCLK = GPIO_7;
	public static final int GPIO_ADC3 = GPIO_8;
	public static final int GPIO_CAM_VD = GPIO_8;
	public static final int GPIO_ADC4 = GPIO_9;
	public static final int GPIO_CAM_HD = GPIO_9;
	public static final int GPIO_ADC5 = GPIO_10;
	public static final int GPIO_CAM_D7 = GPIO_10;
	public static final int GPIO_ADC6 = GPIO_11;
	public static final int GPIO_CAM_D6 = GPIO_11;
	public static final int GPIO_ADC7 = GPIO_12;
	public static final int GPIO_CAM_D5 = GPIO_12;
	public static final int GPIO_DAC1 = GPIO_13;
	public static final int GPIO_CAM_D4 = GPIO_13;
	public static final int GPIO_DAC0 = GPIO_14;
	public static final int GPIO_CAM_D3 = GPIO_14;
	public static final int GPIO_CAN0_TXD = GPIO_15;
	public static final int GPIO_CAM_D2 = GPIO_15;
	public static final int GPIO_CAN0_RXD = GPIO_16;
	public static final int GPIO_CAM_D1 = GPIO_16;
	public static final int GPIO_CAN1_TXD = GPIO_17;
	public static final int GPIO_CAM_D0 = GPIO_17;
	public static final int GPIO_CAN1_RXD = GPIO_18;
	public static final int GPIO_SD_CLK = GPIO_19;
	public static final int GPIO_SD_CMD = GPIO_20;
	public static final int GPIO_SD_DATA3 = GPIO_21;
	public static final int GPIO_SD_DATA2 = GPIO_22;
	public static final int GPIO_SD_DATA1 = GPIO_23;
	public static final int GPIO_SD_DATA0 = GPIO_24;
	public static final int GPIO_SD_CD = GPIO_25;
	public static final int GPIO_SD_WP = GPIO_26;
	public static final int GPIO_SPIM_CLK = GPIO_27;
	public static final int GPIO_SPIM_SS0 = GPIO_28;
	public static final int GPIO_SPIM_MOSI = GPIO_29;
	public static final int GPIO_SPIM_MISO = GPIO_30;
	public static final int GPIO_SPIM_IO2 = GPIO_31;
	public static final int GPIO_SPIM_IO3 = GPIO_32;
	public static final int GPIO_SPIM_SS1 = GPIO_33;
	public static final int GPIO_SPIM_SS2 = GPIO_34;
	public static final int GPIO_SPIM_SS3 = GPIO_35;
	public static final int GPIO_SPIS0_CLK = GPIO_36;
	public static final int GPIO_SPIS0_SS = GPIO_37;
	public static final int GPIO_SPIS0_MOSI = GPIO_38;
	public static final int GPIO_SPIS0_MISO = GPIO_39;
	public static final int GPIO_SPIS1_CLK = GPIO_40;
	public static final int GPIO_SPIS1_SS = GPIO_41;
	public static final int GPIO_SPIS1_MOSI = GPIO_42;
	public static final int GPIO_SPIS1_MISO = GPIO_43;
	public static final int GPIO_I2C0_SCL = GPIO_44;
	public static final int GPIO_I2C0_SDA = GPIO_45;
	public static final int GPIO_I2C1_SCL = GPIO_46;
	public static final int GPIO_I2C1_SDA = GPIO_47;
	public static final int GPIO_UART0_TXD = GPIO_48;
	public static final int GPIO_UART0_RXD = GPIO_49;
	public static final int GPIO_UART0_RTS = GPIO_50;
	public static final int GPIO_UART0_CTS = GPIO_51;
	public static final int GPIO_UART0_DTR = GPIO_52;
	public static final int GPIO_UART1_TXD = GPIO_52;
	public static final int GPIO_PWM4 = GPIO_52;
	public static final int GPIO_UART0_DSR = GPIO_53;
	public static final int GPIO_UART1_RXD = GPIO_53;
	public static final int GPIO_PWM5 = GPIO_53;
	public static final int GPIO_UART0_DCD = GPIO_54;
	public static final int GPIO_UART1_RTS = GPIO_54;
	public static final int GPIO_PWM6 = GPIO_54;
	public static final int GPIO_UART0_RI = GPIO_55;
	public static final int GPIO_UART1_CTS = GPIO_55;
	public static final int GPIO_PWM7 = GPIO_55;
	public static final int GPIO_PWM0 = GPIO_56;
	public static final int GPIO_PWM1 = GPIO_57;
	public static final int GPIO_PWM2 = GPIO_58;
	public static final int GPIO_I2S_SDAO = GPIO_60;
	public static final int GPIO_I2S_SDAI = GPIO_61;
	public static final int GPIO_I2S_BCLK = GPIO_62;
	public static final int GPIO_I2S_LRCLK = GPIO_63;
	public static final int GPIO_I2S_MCLK = GPIO_64;
	public static final int GPIO_I2SM_CLK22 = GPIO_65;
	public static final int GPIO_I2SM_CLK24 = GPIO_66;
	
	public static final char CMD_HIGH = 'H';
	public static final char CMD_LOW = 'L';
	public static final char CMD_READ = 'R';
	public static final char CMD_INPUT = 'I';
	public static final char CMD_OUTPUT = 'O';
	public static final char CMD_PULLUP_ON = 'P';
	public static final char CMD_PULLUP_OFF = 'p';
	public static final char CMD_ECHO_ON = 'E';
	public static final char CMD_ECHO_OFF = 'e';
	public static final char CMD_RESET = '#';
	public static final char CMD_HELP = '?';
	public static final String LINEEND = "\r\n";
	
	private static final String[] GPIO_PIN_DESCRIPTION = {
		"VBUS_DISCHG/GPIO0",
		"OC_N/GPIO1",
		"PSW_N/GPIO2",
		"VBUS_DTC/GPIO3",
		"ENET_LED0/GPIO4",
		"ENET_LED1/GPIO5",
		"ADC1/CAM_XCLK/GPIO6",
		"ADC2/CAM_PCLK/GPIO7",
		"ADC3/CAM_VD/GPIO8",
		"ADC4/CAM_HD/GPIO9",
		"ADC5/CAM_D7/GPIO10",
		"ADC6/CAM_D6/GPIO11",
		"ADC7/CAM_D5/GPIO12",
		"DAC1/CAM_D4/GPIO13",
		"DAC0/CAM_D3/GPIO14",
		"CAN0_TXD/CAM_D2/GPIO15",
		"CAN0_RXD/CAM_D1/GPIO16",
		"CAN1_TXD/CAM_D0/GPIO17",
		"CAN1_RXD/GPIO_18",
		"SD_CLK/GPIO19",
		"SD_CMD/GPIO20",
		"SD_DATA3/GPIO21",
		"SD_DATA2/GPIO22",
		"SD_DATA1/GPIO23",
		"SD_DATA0/GPIO24",
		"SD_CD/GPIO25",
		"SD_WP/GPIO26",
		"SPIM_CLK/GPIO27",
		"SPIM_SS0/GPIO28",
		"SPIM_MOSI/GPIO29",
		"SPIM_MISO/GPIO30",
		"SPIM_IO2/GPIO31",
		"SPIM_IO3/GPIO32",
		"SPIM_SS1/GPIO33",
		"SPIM_SS2/GPIO34",
		"SPIM_SS3/GPIO35",
		"SPIS0_CLK/GPIO36",
		"SPIS0_SS/GPIO37",
		"SPIS0_MOSI/GPIO38",
		"SPIS0_MISO/GPIO39",
		"SPIS1_CLK/GPIO40",
		"SPIS1_SS/GPIO41",
		"SPIS1_MOSI/GPIO42",
		"SPIS1_MISO/GPIO43",
		"I2C0_SCL/GPIO44",
		"I2C0_SDA/GPIO45",
		"I2C1_SCL/GPIO46",
		"I2C1_SDA/GPIO47",
		"UART0_TXD/GPIO48",
		"UART0_RXD/GPIO49",
		"UART0_RTS/GPIO50",
		"UART0_CTS/GPIO51",
		"UART0_DTR/UART1_TXD/PWM4/GPIO52",
		"UART0_DSR/UART1_RXD/PWM5/GPIO53",
		"UART0_DCD/UART1_RTS/PWM6/GPIO54",
		"UART0_RI/UART1_CTS/PWM7/GPIO55",
		"PWM0/GPIO56",
		"PWM1/GPIO57",
		"PWM2/GPIO58",
		"GPIO59",
		"I2S_SDAO/GPIO60",
		"I2S_SDAI/GPIO61",
		"I2S_BCLK/GPIO62",
		"I2S_LRCLK/GPIO63",
		"I2S_MCLK/GPIO64",
		"I2SM_CLK22/GPIO65",
		"I2SM_CLK24/GPIO66"
	};
	
	/** Get the description of a pin
	 * 
	 * @param pin The GPIO pin to get the description of
	 * @return A String describing the pin or null
	 */
	public static String getPinFunction(int pin)
	{
		if (pin < GPIO_PIN_DESCRIPTION.length && pin >= 0)
		{
			return GPIO_PIN_DESCRIPTION[pin];
		}
		else
		{
			return null;
		}
	}
	
	
	
	private final SerialPort serial;
	
	/** Construct a FT90x UART to GPIO Bridge
	 * 
	 * @param port The name of the serial port to use
	 */
	public FT90x(String port) {
		this.serial = new JSSCSerialPort();
		
		try
		{
			Properties p = AppProperties.getProperties();
			String strBaud = p.getProperty("ftdi.ft90x.serial.baud","19200");
			String strDatabits = p.getProperty("ftdi.ft90x.serial.databits","8");
			String strParity = p.getProperty("ftdi.ft90x.serial.parity","N");
			String strStopbits = p.getProperty("ftdi.ft90x.serial.stopbits","1");
			
			int baud = 19200;
			SerialPort.DATABITS databits = SerialPort.DATABITS.DATABITS_8;
			SerialPort.PARITY parity = SerialPort.PARITY.PARITY_NONE;
			SerialPort.STOPBITS stopbits = SerialPort.STOPBITS.STOPBITS_1;

			
			baud = Integer.parseInt(strBaud);

			switch (Integer.parseInt(strDatabits))
			{
			case 5: databits = SerialPort.DATABITS.DATABITS_5; break;
			case 6: databits = SerialPort.DATABITS.DATABITS_6; break;
			case 7: databits = SerialPort.DATABITS.DATABITS_7; break;
			case 8: databits = SerialPort.DATABITS.DATABITS_8; break;
			}
			
			strParity = strParity.trim().toUpperCase();
			if (strParity.equals("E") || strParity.equals("EVEN"))
				parity = SerialPort.PARITY.PARITY_EVEN;
			else if (strParity.equals("M") || strParity.equals("MARK"))
				parity = SerialPort.PARITY.PARITY_MARK;
			else if (strParity.equals("N") || strParity.equals("NONE"))
				parity = SerialPort.PARITY.PARITY_NONE;
			else if (strParity.equals("O") || strParity.equals("ODD"))
				parity = SerialPort.PARITY.PARITY_ODD;
			else if (strParity.equals("S") || strParity.equals("SPACE"))
				parity = SerialPort.PARITY.PARITY_SPACE;
					
			float fStopBits = Float.parseFloat(strStopbits);
			if (fStopBits == 1.0f)
				stopbits = SerialPort.STOPBITS.STOPBITS_1;
			else if (fStopBits == 1.5f)
				stopbits = SerialPort.STOPBITS.STOPBITS_1_5;
			else if (fStopBits == 2.0f)
				stopbits = SerialPort.STOPBITS.STOPBITS_2;
			
			serial.open(port, baud, databits, stopbits, parity);
			System.out.println("serial.open("+port+", "+baud+", "+databits+", "+stopbits+", "+parity+");");
			
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		
	}
	
	/** Write a String to the serial port
	 * 
	 * @param s The String to write
	 */
	public void write(String s)	{ serial.write(s); }
	
	/** Write a byte to the serial port
	 * 
	 * @param b The byte to write
	 */
	public void write(byte b) { serial.write(b); }
	
	/** Read a byte from the serial port
	 * 
	 * @return The value read
	 */
	public byte read() { return serial.read(); }
	
	/** Flush the data from the serial port
	 *  Wait for serial data to finish being transmitted from the serial port
	 */
	public void flush() { serial.flush(); }
	
	/** Clear the serial port buffers
	 * 
	 */
	public void clear() { serial.clear(); }
	
	/** Close the serial port 
	 * 
	 */
	public void close() { serial.close(); }
	
	/** Send a command to the FT90x
	 * 
	 * @param c The command character to send
	 */
	public void sendCommand(char c)
	{
		write(c+LINEEND);
	}
	
	/** Send a command to the FT90x
	 * 
	 * @param c The command character to send
	 * @param pin The pin to execute that command on
	 */
	public void sendCommand(char c, int pin)
	{
		write(c+" "+pin+LINEEND);
	}
	
	/** Set the logic level of a GPIO pin
	 * 
	 * @param pin The pin to change the value of
	 * @param value true for a High logic level, false for a Low logic level
	 */
	public void set(int pin, boolean value)
	{
		if (value == true) sendCommand(CMD_HIGH,pin);
		else               sendCommand(CMD_LOW,pin);
	}
	
	/** Get the current logic level of a GPIO pin
	 * 
	 * @param pin The pin to read
	 * @return true for a High logic level, false for a Low logic level
	 */
	public boolean get(int pin)
	{
		CharBuffer cb = CharBuffer.allocate(16);
		int i = 0;
		int cr_location = -1;
		
		clear();
		sendCommand(CMD_READ,pin);
		
		try {
			char c;
			do {
				c = (char) serial.read(1000);
				
				if (cb.hasRemaining())
					cb.put(c);
				
				if (c == '\r')
					cr_location = i;
				
				i++;
			} while (c != '\n');
		} catch (TimeoutException ex) {
			ex.printStackTrace();
			return false;
		}
		
		while(serial.available() > 0)
			read();
		
		if (cr_location == 1)
		{
			if (cb.get(0) == '0')
				return false;
			else
				return true;
		}
		else
		{
			System.err.println("get: Error. Recieved \""+String.valueOf(cb.array(), 0, cb.position())+"\"");
			return false;
		}
	}
	
	/** Change the direction of a GPIO pin
	 * 
	 * @param pin The pin to change direction of
	 * @param dir The direction to set the pin to
	 */
	public void dir(int pin, DIRECTION dir)
	{
		if (dir == DIRECTION.INPUT) sendCommand(CMD_INPUT, pin);
		else sendCommand(CMD_OUTPUT, pin);
	}
	
	/** Enable or Disable pullups for a GPIO pin
	 * 
	 * @param pin The pin to change pullups on
	 * @param val true for Pullups enabled, false for Pullups disabled
	 */
	public void pullups(int pin, boolean val)
	{
		if (val == true) sendCommand(CMD_PULLUP_ON, pin);
		else sendCommand(CMD_PULLUP_OFF, pin);
	}
	
	/** Control whether data should be echoed back on the serial port
	 * 
	 * @param value true causes data to be sent back when it is sent to the FT90x, 
	 *              false will not send data back and will only send data back as
	 *              a response to a command. 
	 */
	public void echo(boolean value)
	{
		if (value) sendCommand(CMD_ECHO_ON);
		else sendCommand(CMD_ECHO_OFF);
	}
	
	/** Reset the FT90x UART to GPIO Bridge
	 * 
	 */
	public void reset()
	{
		 sendCommand(CMD_RESET);
	}
	
	/** Add a serial port transmitter listener
	 * 
	 * @param spl The listener
	 */
	public void addSerialTransmitListener(SerialPortListener spl)
	{
		serial.addTransmitListener(spl);
	}
	
	/** Add a serial port receiver listener
	 * 
	 * @param spl The listener
	 */
	public void addSerialReceiveListener(SerialPortListener spl)
	{
		serial.addReceiveListener(spl);
	}
	
}
